// Extended Roots, by Domani Turner-Ward, ghostbirding.art@gmail.com, www.ghostbirding.art.
// April 30, 2023. 
// A wearable art piece - crocheted bracer adorned with LEDs controlled by nearby real-time soil moisture measurements.
// Transciever code based on https://iotdesignpro.com/projects/arduino-uno-with-nrf24l01-send-and-receive-temperature-and-humidity-data-wirelessly.
// Soil moisture sensor code based on https://www.makerguides.com/capacitive-soil-moisture-sensor-with-arduino/.

//Code for Arduino connected to the transmitting transciever and soil moisture capacitance sensor.

//Soil Moisture Capacitance Sensor:
int MoistureLevel = 0;

//Transciever:
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
const uint64_t pipeOut = 0xE8E8F0F0E1LL; 
RF24 radio(7, 8); //  CN and CSN  pins of nrf
  //Creates data.m, the data flowing from transmitter to receiver. Can create multiple, with different names; ex, byte z creates data.z
  struct MyData {
   byte m; 
  };
  MyData data;

void setup(){
  Serial.begin(9600); //Needed for both sensor and transmission. Ensure it is equal to rate on reciever code.
 //Transmitter setup
  radio.begin();
  radio.setAutoAck(false);
  radio.setDataRate(RF24_250KBPS);
  radio.openWritingPipe(pipeOut);
}

void loop(){
MoistureLevel = analogRead(A0); //Defines analog input from Pin 0 as "MoistureLevel".
data.m = MoistureLevel; //Defines data.m (the data flowing from transmitter) as data from MoistureLevel.
  radio.write(&data, sizeof(MyData)); //Transmit data.m
  Serial.println(data.m); // Display current soil moisture capacitance measurement in Serial Monitor.
  return; //Create new line in Serial Monitor.
 }
  delay(1000); //Pause for one second before returning to beginning of loop.
}

 